package inria.meije.rc.sugarcubes;

public class Loop extends Cyclic
{
    protected boolean first = true, endReached = false;

    public Loop(Instruction inst){ super(inst); }

    public String toString(){ return "loop "+body+" end"; }
    protected Instruction rest(){ 
        return new Seq(body.residual(),new Loop(freshBody()));
    }
    protected byte activation(Context context){
        for(;;){
            byte res = body.activ(context);
            if (res != TERM){
                first = endReached = false;
                return res;
            }    
            if (first || endReached){
                System.out.println("warning: instantaneous loop detected");
                first = endReached = false;
                return STOP;
            }
            endReached = true;
            body = freshBody();
        }
    }
}
