package inria.meije.rc.sugarcubes;

public class PosConfig extends Config
{
    protected String eventName = null;
    protected JavaStringExpression eventNameToEvaluate = null;

    public PosConfig(String eventName){ this(new JavaStringValue(eventName)); }
    public PosConfig(JavaStringExpression expr){ eventNameToEvaluate = expr;}

    public String toString(){ return eventNameToEvaluate.toString(); }
    public boolean evaluate(Domain domain){
        return domain.isGenerated(eventName);
    }
    protected void computeName(Domain domain){
    	eventName = eventNameToEvaluate.evaluate(domain.currentLink());
    	eventNameToEvaluate = new JavaStringValue(eventName);
    }
    public boolean fixed(Domain domain){
        if(eventName == null) computeName(domain);
        return domain.isGenerated(eventName)?true:domain.isEndOfInstant();
    }
}
