package inria.meije.rc.sugarcubes;

public class When extends BinaryInstruction
{
    protected Config config;
    protected boolean confEvaluated = false, value;

    public When(Config config,Instruction th,Instruction el){ 
        this.config = config;
        left = th;
        right = el;
    }
    public When(String event,Instruction th,Instruction el){ 
        this(new PosConfig(event),th,el);
    }

    public String toString(){ 
        return "when "+config+" then "+left+" else "+right+" end"; 
    }
    protected Instruction rest(){ 
        if (confEvaluated) return value ? left.residual() : right.residual();
        return super.residual();
    }
    public Object clone(){
        When inst = (When)super.clone();
        inst.config = (Config)config.clone();
        return inst;
    }
    protected byte activation(Context context){ 
        Domain domain = (Domain)context;
        if (!confEvaluated){
            if (!config.fixed(domain)) return SUSP;
            value = config.evaluate(domain);
            confEvaluated = true;
            if(domain.isEndOfInstant()) return STOP;
        }
        return value ? left.activ(domain) : right.activ(domain);
    }
    public void notifyTerminationToJava(Context context){
        if(confEvaluated){
            if(value)
                right.notifyTerminationToJava(context);
            else
                left.notifyTerminationToJava(context);
        }
    }
    public void notifyWarmUpToJava(Context context){
        if(confEvaluated){
            if(value)
                right.notifyWarmUpToJava(context);
            else
                left.notifyWarmUpToJava(context);
        }
	}
    public void notifyFreezeToJava(Context context){
        if(confEvaluated){
            if(value)
                right.notifyFreezeToJava(context);
            else
                left.notifyFreezeToJava(context);
        }
    }
}
