package inria.meije.rc.sugarcubes.migration;

import inria.meije.rc.sugarcubes.*;
import java.awt.*;
import java.util.*;

public class ReactiveSite extends EventMachine implements Runnable
{
    public static String localSiteName = null;
    public static String registryHostName = null;
    public static Vector windows = new Vector();
    public static ReactiveSite machine = null;
    public static SugarCubesServer siteServer = null;

    public static void init(String[] argv){
        if(argv.length != 2){
            System.err.println("usage: java inria.meije.rc.sugarcubes.migration.ReactiveSite hostname siteName");
            System.exit(0);
        }
        registryHostName = argv[0];
        localSiteName = argv[1];
    }
    public static void main(String[] argv){
        init(argv);
        machine = new ReactiveSite(localSiteName,registryHostName);
        try{
            siteServer = new SugarCubesServerImpl(registryHostName,localSiteName,machine);
        }
        catch(Exception e){
            System.err.println("cannot build server for this reactive site. Exiting !");
            System.exit(1);
        }
        machine.run();
    }

    public ReactiveSite(String n,String host){
        super(new JavaStringValue(n),new JavaObjectValue(null),new Halt(),new JavaEmptyInstruction(),new JavaEmptyInstruction(),new JavaEmptyInstruction());
        localSiteName = n;
        registryHostName = host;
    }

    public void run(){
        for(;;){
            machine.react();
            for(int i = 0;i<windows.size();i++){
                Component c = ((Component)windows.elementAt(i));
                c.update(c.getGraphics());
            }
        }
    }
}
